#ifndef PDL_GEN_H
#define PDL_GEN_H

#include "deftbl.h"

#ifdef ELI_ARG
#undef ELI_ARG
#endif

#if defined(__STDC__) || defined(__cplusplus)
#define ELI_ARG(proto)    proto
#else
#define ELI_ARG(proto)    ()
#endif

#include "LIGA.h"
#include "Coord.h"
#include "envmod.h"
#include "List.h"
#include "List.h"
#include "envmod.h"

#define TYPE int
extern TYPE Getint ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void Setint ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void Resetint ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE DefTableKey
extern TYPE GetDefTableKey ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetDefTableKey ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetDefTableKey ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE Environment
extern TYPE GetEnvironment ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetEnvironment ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetEnvironment ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE SEQAttrrule
extern TYPE GetSEQAttrrule ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetSEQAttrrule ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetSEQAttrrule ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE SEQExpr
extern TYPE GetSEQExpr ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetSEQExpr ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetSEQExpr ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE CoordRef
extern TYPE GetCoordRef ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetCoordRef ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetCoordRef ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE
#define TYPE TList
extern TYPE GetTList ELI_ARG((int _Property, DefTableKey key, TYPE deflt));
extern void SetTList ELI_ARG((int _Property, DefTableKey key, TYPE _add, TYPE _replace));
extern void ResetTList ELI_ARG((int _Property, DefTableKey key, TYPE _val));
#undef TYPE

#define SetClpValue(key, _add, _replace)   \
		Setint(1, (key), (_add), (_replace))
#define ResetClpValue(key, _val)   \
		Resetint(1, (key), (_val))
#define GetClpValue(key, deflt)   \
		Getint(1, (key), (deflt))
#define SetTermType(key, _add, _replace)   \
		SetDefTableKey(2, (key), (_add), (_replace))
#define ResetTermType(key, _val)   \
		ResetDefTableKey(2, (key), (_val))
#define GetTermType(key, deflt)   \
		GetDefTableKey(2, (key), (deflt))
#define SetOldTerm(key, _add, _replace)   \
		Setint(3, (key), (_add), (_replace))
#define ResetOldTerm(key, _val)   \
		Resetint(3, (key), (_val))
#define GetOldTerm(key, deflt)   \
		Getint(3, (key), (deflt))
#define SetAttrKind(key, _add, _replace)   \
		Setint(4, (key), (_add), (_replace))
#define ResetAttrKind(key, _val)   \
		Resetint(4, (key), (_val))
#define GetAttrKind(key, deflt)   \
		Getint(4, (key), (deflt))
#define SetAttrType(key, _add, _replace)   \
		Setint(5, (key), (_add), (_replace))
#define ResetAttrType(key, _val)   \
		Resetint(5, (key), (_val))
#define GetAttrType(key, deflt)   \
		Getint(5, (key), (deflt))
#define SetAttrClass(key, _add, _replace)   \
		Setint(6, (key), (_add), (_replace))
#define ResetAttrClass(key, _val)   \
		Resetint(6, (key), (_val))
#define GetAttrClass(key, deflt)   \
		Getint(6, (key), (deflt))
#define SetAttrProdDid(key, _add, _replace)   \
		Setint(7, (key), (_add), (_replace))
#define ResetAttrProdDid(key, _val)   \
		Resetint(7, (key), (_val))
#define GetAttrProdDid(key, deflt)   \
		Getint(7, (key), (deflt))
#define SetAttrSymCompNo(key, _add, _replace)   \
		Setint(8, (key), (_add), (_replace))
#define ResetAttrSymCompNo(key, _val)   \
		Resetint(8, (key), (_val))
#define GetAttrSymCompNo(key, deflt)   \
		Getint(8, (key), (deflt))
#define SetChnChk(key, _add, _replace)   \
		Setint(9, (key), (_add), (_replace))
#define ResetChnChk(key, _val)   \
		Resetint(9, (key), (_val))
#define GetChnChk(key, deflt)   \
		Getint(9, (key), (deflt))
#define SetDefKind(key, _add, _replace)   \
		Setint(10, (key), (_add), (_replace))
#define ResetDefKind(key, _val)   \
		Resetint(10, (key), (_val))
#define GetDefKind(key, deflt)   \
		Getint(10, (key), (deflt))
#define SetDefinedSym(key, _add, _replace)   \
		Setint(11, (key), (_add), (_replace))
#define ResetDefinedSym(key, _val)   \
		Resetint(11, (key), (_val))
#define GetDefinedSym(key, deflt)   \
		Getint(11, (key), (deflt))
#define SetDid(key, _add, _replace)   \
		Setint(12, (key), (_add), (_replace))
#define ResetDid(key, _val)   \
		Resetint(12, (key), (_val))
#define GetDid(key, deflt)   \
		Getint(12, (key), (deflt))
#define SetIdent(key, _add, _replace)   \
		Setint(13, (key), (_add), (_replace))
#define ResetIdent(key, _val)   \
		Resetint(13, (key), (_val))
#define GetIdent(key, deflt)   \
		Getint(13, (key), (deflt))
#define SetAttrScope(key, _add, _replace)   \
		SetEnvironment(14, (key), (_add), (_replace))
#define ResetAttrScope(key, _val)   \
		ResetEnvironment(14, (key), (_val))
#define GetAttrScope(key, deflt)   \
		GetEnvironment(14, (key), (deflt))
#define SetAttrib(key, _add, _replace)   \
		SetSEQAttrrule(15, (key), (_add), (_replace))
#define ResetAttrib(key, _val)   \
		ResetSEQAttrrule(15, (key), (_val))
#define GetAttrib(key, deflt)   \
		GetSEQAttrrule(15, (key), (deflt))
#define SetUpAttrib(key, _add, _replace)   \
		SetSEQAttrrule(16, (key), (_add), (_replace))
#define ResetUpAttrib(key, _val)   \
		ResetSEQAttrrule(16, (key), (_val))
#define GetUpAttrib(key, deflt)   \
		GetSEQAttrrule(16, (key), (deflt))
#define SetLowAttrib(key, _add, _replace)   \
		SetSEQAttrrule(17, (key), (_add), (_replace))
#define ResetLowAttrib(key, _val)   \
		ResetSEQAttrrule(17, (key), (_val))
#define GetLowAttrib(key, deflt)   \
		GetSEQAttrrule(17, (key), (deflt))
#define SetemptyHEADs(key, _add, _replace)   \
		SetSEQExpr(18, (key), (_add), (_replace))
#define ResetemptyHEADs(key, _val)   \
		ResetSEQExpr(18, (key), (_val))
#define GetemptyHEADs(key, deflt)   \
		GetSEQExpr(18, (key), (deflt))
#define SetChainStarts(key, _add, _replace)   \
		SetSEQAttrrule(19, (key), (_add), (_replace))
#define ResetChainStarts(key, _val)   \
		ResetSEQAttrrule(19, (key), (_val))
#define GetChainStarts(key, deflt)   \
		GetSEQAttrrule(19, (key), (deflt))
#define SetCoord(key, _add, _replace)   \
		SetCoordRef(20, (key), (_add), (_replace))
#define ResetCoord(key, _val)   \
		ResetCoordRef(20, (key), (_val))
#define GetCoord(key, deflt)   \
		GetCoordRef(20, (key), (deflt))
#define SetMakeInh(key, _add, _replace)   \
		Setint(21, (key), (_add), (_replace))
#define ResetMakeInh(key, _val)   \
		Resetint(21, (key), (_val))
#define GetMakeInh(key, deflt)   \
		Getint(21, (key), (deflt))
#define SetInhTo(key, _add, _replace)   \
		SetTList(22, (key), (_add), (_replace))
#define ResetInhTo(key, _val)   \
		ResetTList(22, (key), (_val))
#define GetInhTo(key, deflt)   \
		GetTList(22, (key), (deflt))
#define SetInhFrom(key, _add, _replace)   \
		SetTList(23, (key), (_add), (_replace))
#define ResetInhFrom(key, _val)   \
		ResetTList(23, (key), (_val))
#define GetInhFrom(key, deflt)   \
		GetTList(23, (key), (deflt))
#define SetRuleProd(key, _add, _replace)   \
		SetTList(24, (key), (_add), (_replace))
#define ResetRuleProd(key, _val)   \
		ResetTList(24, (key), (_val))
#define GetRuleProd(key, deflt)   \
		GetTList(24, (key), (deflt))
#define SetRealSym(key, _add, _replace)   \
		Setint(25, (key), (_add), (_replace))
#define ResetRealSym(key, _val)   \
		Resetint(25, (key), (_val))
#define GetRealSym(key, deflt)   \
		Getint(25, (key), (deflt))
#define SetIsApplied(key, _add, _replace)   \
		Setint(26, (key), (_add), (_replace))
#define ResetIsApplied(key, _val)   \
		Resetint(26, (key), (_val))
#define GetIsApplied(key, deflt)   \
		Getint(26, (key), (deflt))
#define SetIsDefined(key, _add, _replace)   \
		Setint(27, (key), (_add), (_replace))
#define ResetIsDefined(key, _val)   \
		Resetint(27, (key), (_val))
#define GetIsDefined(key, deflt)   \
		Getint(27, (key), (deflt))
#define SetSymClass(key, _add, _replace)   \
		Setint(28, (key), (_add), (_replace))
#define ResetSymClass(key, _val)   \
		Resetint(28, (key), (_val))
#define GetSymClass(key, deflt)   \
		Getint(28, (key), (deflt))
#define SetIsGen(key, _add, _replace)   \
		Setint(29, (key), (_add), (_replace))
#define ResetIsGen(key, _val)   \
		Resetint(29, (key), (_val))
#define GetIsGen(key, deflt)   \
		Getint(29, (key), (deflt))
#define SetIsRoot(key, _add, _replace)   \
		Setint(30, (key), (_add), (_replace))
#define ResetIsRoot(key, _val)   \
		Resetint(30, (key), (_val))
#define GetIsRoot(key, deflt)   \
		Getint(30, (key), (deflt))
#define SetRootDid(key, _add, _replace)   \
		Setint(31, (key), (_add), (_replace))
#define ResetRootDid(key, _val)   \
		Resetint(31, (key), (_val))
#define GetRootDid(key, deflt)   \
		Getint(31, (key), (deflt))
#define SetHEADpos(key, _add, _replace)   \
		Setint(32, (key), (_add), (_replace))
#define ResetHEADpos(key, _val)   \
		Resetint(32, (key), (_val))
#define GetHEADpos(key, deflt)   \
		Getint(32, (key), (deflt))
#define SetTAILpos(key, _add, _replace)   \
		Setint(33, (key), (_add), (_replace))
#define ResetTAILpos(key, _val)   \
		Resetint(33, (key), (_val))
#define GetTAILpos(key, deflt)   \
		Getint(33, (key), (deflt))
#define SetNextRule(key, _add, _replace)   \
		SetDefTableKey(34, (key), (_add), (_replace))
#define ResetNextRule(key, _val)   \
		ResetDefTableKey(34, (key), (_val))
#define GetNextRule(key, deflt)   \
		GetDefTableKey(34, (key), (deflt))
#define SetListBase(key, _add, _replace)   \
		SetDefTableKey(35, (key), (_add), (_replace))
#define ResetListBase(key, _val)   \
		ResetDefTableKey(35, (key), (_val))
#define GetListBase(key, deflt)   \
		GetDefTableKey(35, (key), (deflt))
#define SetListProdLg(key, _add, _replace)   \
		Setint(36, (key), (_add), (_replace))
#define ResetListProdLg(key, _val)   \
		Resetint(36, (key), (_val))
#define GetListProdLg(key, deflt)   \
		Getint(36, (key), (deflt))
#define SetChkProd(key, _add, _replace)   \
		SetDefTableKey(37, (key), (_add), (_replace))
#define ResetChkProd(key, _val)   \
		ResetDefTableKey(37, (key), (_val))
#define GetChkProd(key, deflt)   \
		GetDefTableKey(37, (key), (deflt))
#define SetProdKind(key, _add, _replace)   \
		Setint(38, (key), (_add), (_replace))
#define ResetProdKind(key, _val)   \
		Resetint(38, (key), (_val))
#define GetProdKind(key, deflt)   \
		Getint(38, (key), (deflt))
#define SetTreeOrClass(key, _add, _replace)   \
		Setint(39, (key), (_add), (_replace))
#define ResetTreeOrClass(key, _val)   \
		Resetint(39, (key), (_val))
#define GetTreeOrClass(key, deflt)   \
		Getint(39, (key), (deflt))

extern struct PropList PDLk[];


extern DefTableKey CloneKey ELI_ARG((DefTableKey key));
/* Clone a definition
 *    On entry-
 *       key=a valid definition
 *    On exit-
 *       CloneKey=Unique definition with the same properties
 *                and property values as key
 ***/

#ifdef MONITOR
extern void pdl_mon_properties ELI_ARG((DefTableKey));
#endif

#endif
