#define NONLITCOUNT 9
#define LITCOUNT 36
#define NTOKENS 45
#define EOFTOKEN 1
#if defined(__cplusplus) || defined(__STDC__)
extern void mkidn(char *, int, int *, int *),
 c_mkint(char *, int, int *, int *),
 p_mkstr(char *, int, int *, int *),
 c_mkstr(char *, int, int *, int *),
 mkstr(char *, int, int *, int *),
 dummy1(char *, int, int *, int *);
#else
extern void mkidn(),
 c_mkint(),
 p_mkstr(),
 c_mkstr(),
 mkstr(),
 dummy1();
#endif
#if defined(__cplusplus) || defined(__STDC__)
extern char *aux_p_string_or_c_char(char *, int),
 *auxCString(char *, int),
 *auxPascalComment(char *, int),
 *auxEOL(char *, int),
 *auxCComment(char *, int),
 *auxEOL(char *, int),
 *dummy2(char *, int);
#else
extern char *aux_p_string_or_c_char(),
 *auxCString(),
 *auxPascalComment(),
 *auxEOL(),
 *auxCComment(),
 *auxEOL(),
 *dummy2();
#endif
#ifdef MONITOR
int mon_nonlit_codes[] = {
 10,
 26,
 19,
 30,
 31,
 15001,
 15001,
 15001,
 15001,
 -1
};
char *mon_token_names[] = {
 "Identifier",
 "C_Integer",
 "P_String",
 "C_String",
 "C_Float",
 "",
 "",
 "",
 "",
 ""
};
#endif

static short CaseTbl[128] = {
  0,  0,  0,  0,  0,  0,  0,  0,     /*   0.  1.  2.  3.  4.  5.  6.  7. */
  0,  2,  3,  0,  0,  0,  0,  0,     /*   8.  9. 10. 11. 12. 13. 14. 15. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  16. 17. 18. 19. 20. 21. 22. 23. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  24. 25. 26. 27. 28. 29. 30. 31. */
  1,  0, 28, 27, 29, 26,  0, 25,     /*  32. ! " # $ % & ' */
 24, 29,  0,  0, 29,  0, 23, 22,     /*  ( ) * + , - . / */
 21,  5,  5,  5,  5,  5,  5,  5,     /*  0 1 2 3 4 5 6 7 */
  5,  5, 20, 29, 19, 29,  0,  0,     /*  8 9 : ; < = > ? */
  0, 18, 17, 16, 15, 14,  4,  4,     /*  @ A B C D E F G */
  4, 13,  4,  4, 12,  4, 11,  4,     /*  H I J K L M N O */
  4,  4, 10,  9,  8,  7,  4,  6,     /*  P Q R S T U V W */
  4,  4,  4, 29,  0, 29,  0,  4,     /*  X Y Z [ \ ] ^ _ */
  0,  4,  4,  4,  4,  4,  4,  4,     /*  ` a b c d e f g */
  4,  4,  4,  4,  4,  4,  4,  4,     /*  h i j k l m n o */
  4,  4,  4,  4,  4,  4,  4,  4,     /*  p q r s t u v w */
  4,  4,  4,  0, 29,  0,  0,  0};    /*  x y z { | } ~ 127. */

static short ExtCodeTbl[128] = {
  0,  0,  0,  0,  0,  0,  0,  0,     /*   0.  1.  2.  3.  4.  5.  6.  7. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*   8.  9. 10. 11. 12. 13. 14. 15. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  16. 17. 18. 19. 20. 21. 22. 23. */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  24. 25. 26. 27. 28. 29. 30. 31. */
  0,  0,  0,  0, 18,  0,  0,  0,     /*  32. ! " # $ % & ' */
  0, 29,  0,  0,  9,  0,  0,  0,     /*  ( ) * + , - . / */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  0 1 2 3 4 5 6 7 */
  0,  0,  0,  2,  0, 23,  0,  0,     /*  8 9 : ; < = > ? */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  @ A B C D E F G */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  H I J K L M N O */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  P Q R S T U V W */
  0,  0,  0, 25,  0, 27,  0,  0,     /*  X Y Z [ \ ] ^ _ */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  ` a b c d e f g */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  h i j k l m n o */
  0,  0,  0,  0,  0,  0,  0,  0,     /*  p q r s t u v w */
  0,  0,  0,  0, 17,  0,  0,  0};    /*  x y z { | } ~ 127. */
static unsigned char ScanTbl[] = {
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x02, 0x04, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x01, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xD8, 0xD8, 0xD8, 0xD8,	/*  0  1  2  3 */
0xD8, 0xD8, 0xD8, 0xD8,	/*  4  5  6  7 */
0xD8, 0xD8, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xC8, 0xC8, 0xC8,	/*  @  A  B  C */
0xC8, 0xE8, 0xC8, 0xC8,	/*  D  E  F  G */
0xC8, 0x88, 0xC8, 0xC8,	/*  H  I  J  K */
0xC8, 0xC8, 0x48, 0xC8,	/*  L  M  N  O */
0xC8, 0xC8, 0xC8, 0xC8,	/*  P  Q  R  S */
0xC8, 0xC8, 0xC8, 0xC8,	/*  T  U  V  W */
0xC8, 0xC8, 0xC8, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xC8,	/*  \  ]  ^  _ */
0x00, 0xC8, 0xC8, 0xC8,	/*  `  a  b  c */
0xC8, 0xE8, 0xC8, 0xC8,	/*  d  e  f  g */
0xC8, 0xC8, 0xC8, 0xC8,	/*  h  i  j  k */
0xC8, 0xC8, 0xC8, 0xC8,	/*  l  m  n  o */
0xC8, 0xC8, 0xC8, 0xC8,	/*  p  q  r  s */
0xC8, 0xC8, 0xC8, 0xC8,	/*  t  u  v  w */
0xC8, 0xC8, 0xC8, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xFF, 0xFF, 0xFF, 0xFF,	/*  0  1  2  3 */
0xFF, 0xFF, 0xFF, 0xFF,	/*  4  5  6  7 */
0xFF, 0xFF, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xFF, 0xFF, 0xFF,	/*  @  A  B  C */
0xFF, 0xDE, 0xFF, 0xFF,	/*  D  E  F  G */
0xB9, 0xFF, 0xFF, 0xFF,	/*  H  I  J  K */
0xBF, 0xFF, 0xEF, 0xB7,	/*  L  M  N  O */
0xFF, 0xFF, 0xFE, 0xFF,	/*  P  Q  R  S */
0x6F, 0xFB, 0xFF, 0xFF,	/*  T  U  V  W */
0xFF, 0xFD, 0xFF, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xFF,	/*  \  ]  ^  _ */
0x00, 0xFF, 0xFF, 0xFF,	/*  `  a  b  c */
0xFF, 0xFF, 0xFF, 0xFF,	/*  d  e  f  g */
0xFF, 0xFF, 0xFF, 0xFF,	/*  h  i  j  k */
0xFF, 0xFF, 0xFF, 0xFF,	/*  l  m  n  o */
0xFF, 0xFF, 0xFF, 0xFF,	/*  p  q  r  s */
0xFF, 0xFF, 0xFF, 0xFF,	/*  t  u  v  w */
0xFF, 0xFF, 0xFF, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x04,	/*  (  )  *  + */
0x00, 0x04, 0x00, 0x00,	/*  ,  -  .  / */
0xF8, 0xF8, 0xF8, 0xF8,	/*  0  1  2  3 */
0xF8, 0xF8, 0xF8, 0xF8,	/*  4  5  6  7 */
0xF8, 0xF8, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xF8, 0xF8, 0xF8,	/*  @  A  B  C */
0xF8, 0xF8, 0xFA, 0xF0,	/*  D  E  F  G */
0xF0, 0xF0, 0xF0, 0xF0,	/*  H  I  J  K */
0xF2, 0xD0, 0xF0, 0xF0,	/*  L  M  N  O */
0x70, 0xF0, 0xE0, 0xF0,	/*  P  Q  R  S */
0xF0, 0xB0, 0xF0, 0xF0,	/*  T  U  V  W */
0xF1, 0xF0, 0xF0, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xF0,	/*  \  ]  ^  _ */
0x00, 0xF8, 0xF8, 0xF8,	/*  `  a  b  c */
0xF8, 0xF8, 0xFA, 0xF0,	/*  d  e  f  g */
0xF0, 0xF0, 0xF0, 0xF0,	/*  h  i  j  k */
0xF2, 0xF0, 0xF0, 0xF0,	/*  l  m  n  o */
0xF0, 0xF0, 0xF0, 0xF0,	/*  p  q  r  s */
0xF0, 0xF0, 0xF0, 0xF0,	/*  t  u  v  w */
0xF1, 0xF0, 0xF0, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0xFF, 0xFF, 0xFF, 0xFF,	/*  0  1  2  3 */
0xFF, 0xFF, 0xFF, 0xFF,	/*  4  5  6  7 */
0xFF, 0xFF, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0xFE, 0xFF, 0xDF,	/*  @  A  B  C */
0xF7, 0xFF, 0xFF, 0x7F,	/*  D  E  F  G */
0xDF, 0xFF, 0xFF, 0xFF,	/*  H  I  J  K */
0xBF, 0xFB, 0xFB, 0xFF,	/*  L  M  N  O */
0xFF, 0xFF, 0xFF, 0xFD,	/*  P  Q  R  S */
0xFF, 0xFF, 0xFF, 0xFF,	/*  T  U  V  W */
0xFF, 0xFF, 0xFF, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0xEF,	/*  \  ]  ^  _ */
0x00, 0xFF, 0xFF, 0xFF,	/*  `  a  b  c */
0xFF, 0xFF, 0xFF, 0xFF,	/*  d  e  f  g */
0xFF, 0xFF, 0xFF, 0xFF,	/*  h  i  j  k */
0xFF, 0xFF, 0xFF, 0xFF,	/*  l  m  n  o */
0xFF, 0xFF, 0xFF, 0xFF,	/*  p  q  r  s */
0xFF, 0xFF, 0xFF, 0xFF,	/*  t  u  v  w */
0xFF, 0xFF, 0xFF, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00,	/*  |  }  ~  127. */
0x00, 0x00, 0x00, 0x00,	/*   0.   1.   2.   3. */
0x00, 0x00, 0x00, 0x00,	/*   4.   5.   6.   7. */
0x00, 0x00, 0x00, 0x00,	/*   8.   9.  10.  11. */
0x00, 0x00, 0x00, 0x00,	/*  12.  13.  14.  15. */
0x00, 0x00, 0x00, 0x00,	/*  16.  17.  18.  19. */
0x00, 0x00, 0x00, 0x00,	/*  20.  21.  22.  23. */
0x00, 0x00, 0x00, 0x00,	/*  24.  25.  26.  27. */
0x00, 0x00, 0x00, 0x00,	/*  28.  29.  30.  31. */
0x00, 0x00, 0x00, 0x00,	/*  32.  !  "  # */
0x00, 0x00, 0x00, 0x00,	/*  $  %  &  ' */
0x00, 0x00, 0x00, 0x00,	/*  (  )  *  + */
0x00, 0x00, 0x00, 0x00,	/*  ,  -  .  / */
0x07, 0x07, 0x07, 0x07,	/*  0  1  2  3 */
0x07, 0x07, 0x07, 0x07,	/*  4  5  6  7 */
0x07, 0x07, 0x00, 0x00,	/*  8  9  :  ; */
0x00, 0x00, 0x00, 0x00,	/*  <  =  >  ? */
0x00, 0x07, 0x05, 0x07,	/*  @  A  B  C */
0x07, 0x07, 0x06, 0x07,	/*  D  E  F  G */
0x03, 0x07, 0x07, 0x07,	/*  H  I  J  K */
0x07, 0x07, 0x07, 0x07,	/*  L  M  N  O */
0x07, 0x07, 0x07, 0x07,	/*  P  Q  R  S */
0x07, 0x07, 0x07, 0x07,	/*  T  U  V  W */
0x07, 0x07, 0x07, 0x00,	/*  X  Y  Z  [ */
0x00, 0x00, 0x00, 0x07,	/*  \  ]  ^  _ */
0x00, 0x07, 0x07, 0x07,	/*  `  a  b  c */
0x07, 0x07, 0x07, 0x07,	/*  d  e  f  g */
0x07, 0x07, 0x07, 0x07,	/*  h  i  j  k */
0x07, 0x07, 0x07, 0x07,	/*  l  m  n  o */
0x07, 0x07, 0x07, 0x07,	/*  p  q  r  s */
0x07, 0x07, 0x07, 0x07,	/*  t  u  v  w */
0x07, 0x07, 0x07, 0x00,	/*  x  y  z  { */
0x00, 0x00, 0x00, 0x00 }; /*  |  }  ~  127. */
