/* $Id: Names.c,v 1.2 1999/11/24 11:01:07 cogito Exp $ */
/* Copyright, 1992, AG-Kastens, University Of Paderborn */

#include "err.h"
#include "idn.h"
#include "csm.h"
#include "Names.h"

#if defined(__STDC) || defined(__cplusplus)
#include <string.h>
#endif

/* access to csm module */
#define GetStringRef(s) (strng[s])

static char	firstname [120], lastname [20];
static int	num = 0;
static int	idtoken = 4;

#if defined(__STDC) || defined(__cplusplus)
int GenerateName (char *prefix)
#else
int GenerateName (prefix)
    char    *prefix;
#endif
{
    int     newid, lg;
    int     idtoken;

    do {
	num++;
	sprintf (lastname, "%d", num);
	strcpy (firstname, prefix);
	strcat (firstname, lastname);
	lg = strlen (firstname);
	idtoken = -1;
	mkidn (firstname, lg, &idtoken, &newid);
    } while (idtoken != -1);

    return (newid);
}/*GenerateName*/

#if defined(__STDC) || defined(__cplusplus)
int MakeName (char *str)
#else
int MakeName (str)
    char	*str;
#endif
{
    int	newid;
    mkidn (str, strlen (str), &idtoken, &newid);
    return (newid);
}/* MakeName */

#if defined(__STDC) || defined(__cplusplus)
int IdnNumb (int id, int num)
#else
int IdnNumb (id, num)
    int	id, num;
#endif
{
    int	newid, lg;

    strcpy (firstname, GetStringRef (id));
    sprintf (lastname, "%d", num);
    strcat (firstname, lastname);
    lg = strlen (firstname);
    mkidn (firstname, lg, &idtoken, &newid);
    return (newid);
}/* IdnNumb */

#if defined(__STDC) || defined(__cplusplus)
int PreIdnPost (char *pre, int sym, char *post)
#else
int PreIdnPost (pre, sym, post)
    char	*pre, *post;
    int		sym;
#endif
{
    int	newid, lg;

    strcpy (firstname, pre);
    strcpy (lastname, GetStringRef (sym));
    strcat (firstname, lastname);
    strcpy (lastname, post);
    strcat (firstname, lastname);
    lg = strlen (firstname);
    mkidn (firstname, lg, &idtoken, &newid);
    return (newid);
}/* PreIdnPost */

