#ifndef PTABS_H
#define PTABS_H

/* generated constants */


#define BASE		1

#define PAEOF		1

#define STPROD		41



/* generated tables which are not */
/* changable by optimization      */


static unsigned char conncode[]  =  {

  10,  11,  12,  13,  14,  15,  16,  17,  18,  19,  20,  21,  22,  23,  24,  25,
  26,  27,  28,  29,  30,  31,  32,  33,  34,  35,  36,  37,  38,  39,  40,  41,
  42,  43,  44,  45,  46,  47,  48,  49,  50,   0 
};



static unsigned char lhs [] =  {

      0,     1,     1,     2,     2,     2,     2,     7,     7,     3,     3
,     4,     4,     5,     5,     6,     6,     8,     8,     8,     9,     9
,     9,     9,    12,    12,    12,    12,    13,    10,    10,    10,    14
,    14,    15,    15,    16,    17,    17,    11,    11,    18
};



static unsigned char len [] =  {

      1,     3,     0,     3,     3,     3,     3,     2,     0,     3,     1
,     3,     1,     3,     1,     3,     1,     2,     2,     1,     2,     3
,     2,     2,     1,     1,     7,     7,     6,     1,     2,     3,     2
,     1,     2,     0,     4,     2,     1,     1,     2,     2
};



static unsigned char cont[]  =  {

   1,   4,   4,   4,   4,   2,   1,   1,   8,  23,   2,   8,   8,   8,   9,   2,
   8,  12,  16,   8,   8,   8,   2,  12,   9,   9,  21,  17,   8,  18,   8,  19,
   8,   8,  18,   8,  22,  19,   8,  23,  24,  25,   8,  26,  28,   8,   2,  26,
   8,   9,  22,   9,   8,  24,  24 
};



static char terminf[]  =  {

0x00,0x00,0x00,0x00,0x00,0x00,0x00,
};



/* macro for accessing the terminal-table */
/* the Row Displacement Scheme is performed for the terminal-table */

#define SIGMAP(row , col) (sigmap[row][col >> 3] >> (col & 0x0007)) & 0x01

#define GET_TTABENTRY( RorS, Act, term ) \
	{\
	  register    U_SHORT j;\
	  j = conv[ term ]; \
	  if( SIGMAP( sigrowind[RorS], sigcolind[j] ) )  { \
	    j = ttab[ trowptr[RorS] + j ]; \
	    Act  = j & ACTIONMASK; \
	    RorS = j & OPERANDMASK; \
	  }\
	  else \
	    Act  = 0; \
	}

static unsigned char conv [] =  {

      0,     0,     1,     2,     3,     4,     5,     6,     7,     8,     9
,    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,    20
,    21,    22,    23,    24,    25,    26,    27
};



static unsigned char sigrowind [] =  {

      0,     1,     1,     1,     1,     2,     3,     0,     4,     5,     6
,     4,     7,     4,     8,     6,     7,     9,    10,     4,     4,     4
,     6,     9,     8,     8,    11,    12,     4,    13,     4,    14,     4
,     4,    13,     4,    15,    14,     4,    16,    17,    18,     4,    19
,    20,     4,     6,    19,     4,     8,    15,     8,     4,    21,    17
};



static unsigned char sigcolind [] =  {

      0,     1,     2,     3,     2,     2,     2,     4,     5,     6,     7
,     7,     7,     8,     8,     8,     9,    10,    11,     8,    12,    13
,    14,    15,    16,    17,    17,    18
};



static unsigned char sigmap[][3] =  {

 0x05,0x00,0x00,0x08,0x00,0x00,0x02,0x00,0x00,0x01,0x00,0x00,0x10,0x00,0x00,0x22
,0x40,0x00,0x22,0x00,0x00,0x50,0x00,0x00,0x32,0x00,0x00,0x90,0x00,0x00,0x00,0x01
,0x00,0x00,0x10,0x00,0x00,0x02,0x00,0x00,0x04,0x00,0x00,0x08,0x00,0x00,0x20,0x00
,0x00,0x40,0x00,0x00,0x80,0x00,0x00,0x00,0x01,0x10,0x00,0x02,0x10,0x00,0x04,0x10
,0x80,0x00
};



static unsigned char trowptr[] = {

     0,     0,     4,     5,     6,     0,    65,     0,     3,    10,    11,
     3,     6,     7,    15,    16,     6,    18,    20,    13,    14,    19,
    30,    18,    35,    35,     7,    21,    33,    24,    37,    27,    39,
    40,    31,    42,    29,    33,    42,    30,    30,    30,    48,    49,
    50,    51,    58,    49,    53,    60,    41,    60,    56,    56,    41 
};



static unsigned short ttab [] =  {

 0x2002,0x1007,0x1003,0x102b,0x1002,0x1001,0x1004,0x1011,0x100c,0x1008,0x1009
,0x2027,0x2010,0x100e,0x4012,0x100d,0x2013,0x200a,0x2027,0x100b,0x1018,0x4014
,0x4011,0x2013,0x1010,0x1014,0x4016,0x1021,0x1013,0x1015,0x1012,0x200c,0x4028
,0x4018,0x4019,0x101b,0x2008,0x101c,0x1017,0x101a,0x101d,0x101e,0x1019,0x2008
,0x101f,0x1020,0x401a,0x1022,0x1023,0x1024,0x1027,0x1026,0x1028,0x1029,0x102a
,0x401c,0x401d,0x1030,0x401e,0x200e,0x4020,0x2023,0x1034,0x1035,0x4024,0x8000
,0x102f,0x1032,0x2023,0x0000,0x0000,0x0000,0x0000,0x0000,0x102d,0x102c,0x0000
,0x4021,0x0000,0x2026
};



/* macro for accessing the nonterminal-table */
/* the Row Displacement Scheme is performed for the nonterminal-table */

#define GET_NTABENTRY(RorS, Act, State, lhsnt) \
	{\
	  register      U_SHORT j;\
	  j = ntab[ nrowptr[State] + lhsnt ]; \
	  Act = j & ACTIONMASK; \
	  RorS = j & OPERANDMASK; \
	}

static unsigned char nrowptr[] = {

     0,     0,     0,     0,     0,     0,     0,     2,     0,     0,     0,
     1,     2,     0,     0,     0,     5,     5,     3,     0,     0,     0,
     0,    12,    10,    11,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     6,     0,     0,     7,     0,     0,     0,     0,    17,
     9,     0,     0,    19,     0,    10,     0,    15,    11,    15,     0 
};



static unsigned short ntab [] =  {

 0x6006,0x9000,0x6005,0x9001,0x6005,0x9003,0x9006,0x900f,0x9009,0x9004,0x600f
,0x600a,0x600a,0x600f,0x6016,0x9017,0x900b,0x9015,0x9007,0x6025,0x901b,0x6016
,0x9005,0x6031,0x900d,0x901f,0x6033,0x602e,0x6036,0x602e,0x9022,0x6033,0x9025
};





#endif

static	char *state2terms[] = {
	"\"BACKEND\", \"EXPAND\", \"ORDER\", \"OPTIM\" or \"EOF\"",	/* state 1 */
	"\":\"",	/* state 2 */
	"\":\"",	/* state 3 */
	"\":\"",	/* state 4 */
	"\":\"",	/* state 5 */
	"\";\"",	/* state 6 */
	"\"EOF\"",	/* state 7 */
	"\"BACKEND\", \"EXPAND\", \"ORDER\", \"OPTIM\" or \"EOF\"",	/* state 8 */
	"\"Identifier\"",	/* state 9 */
	"\"IntNumber\", \";\" or \",\"",	/* state 10 */
	"\",\" or \";\"",	/* state 11 */
	"\"Identifier\"",	/* state 12 */
	"\"Identifier\" or \"INCLUDING\"",	/* state 13 */
	"\"Identifier\"",	/* state 14 */
	"\"Identifier\", \";\" or \",\"",	/* state 15 */
	"\",\" or \";\"",	/* state 16 */
	"\"Identifier\" or \"INCLUDING\"",	/* state 17 */
	"\"TREE\", \"Identifier\", \"GRAPH\" or \"ARRANGE\"",	/* state 18 */
	"\"FOR\", \"AUTOMATICALLY\", \"FAST\" or \"IN\"",	/* state 19 */
	"\"Identifier\"",	/* state 20 */
	"\"Identifier\"",	/* state 21 */
	"\"Identifier\"",	/* state 22 */
	"\",\" or \";\"",	/* state 23 */
	"\"TREE\", \"Identifier\", \"GRAPH\" or \"ARRANGE\"",	/* state 24 */
	"\"Identifier\", \";\" or \",\"",	/* state 25 */
	"\"Identifier\", \";\" or \",\"",	/* state 26 */
	"\"RULE\"",	/* state 27 */
	"\"SYMB\"",	/* state 28 */
	"\"Identifier\"",	/* state 29 */
	"\"EVAL\"",	/* state 30 */
	"\"Identifier\"",	/* state 31 */
	"\"BEFORE\"",	/* state 32 */
	"\"Identifier\"",	/* state 33 */
	"\"Identifier\"",	/* state 34 */
	"\"EVAL\"",	/* state 35 */
	"\"Identifier\"",	/* state 36 */
	"\"[\"",	/* state 37 */
	"\"BEFORE\"",	/* state 38 */
	"\"Identifier\"",	/* state 39 */
	"\"IntNumber\"",	/* state 40 */
	"\"]\"",	/* state 41 */
	"\".\"",	/* state 42 */
	"\"Identifier\"",	/* state 43 */
	"\"GROUPING\", \"Identifier\" or \"ATTRSPEZ\"",	/* state 44 */
	"\"TREE_NODE\" or \"Identifier\"",	/* state 45 */
	"\"Identifier\"",	/* state 46 */
	"\",\" or \";\"",	/* state 47 */
	"\"GROUPING\", \"Identifier\" or \"ATTRSPEZ\"",	/* state 48 */
	"\"Identifier\"",	/* state 49 */
	"\"Identifier\", \";\" or \",\"",	/* state 50 */
	"\"[\"",	/* state 51 */
	"\"Identifier\", \";\" or \",\"",	/* state 52 */
	"\"Identifier\"",	/* state 53 */
	"\"Identifier\" or \"]\"",	/* state 54 */
	"\"]\"",	/* state 55 */
	(char *)NULL
}; /* of array state2terms[] */
