
/* interface of tree construction functions */

#ifndef TREECON_H
#define TREECON_H
#include "eliproto.h"

#include "err.h"

#include "nodeptr.h"

#include "HEAD.h"


extern void InitTree ELI_ARG((void));

extern void FreeTree ELI_ARG((void));

extern NODEPTR MkCon ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConProd ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConLHS ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConAlt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConElement ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConIdent ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkConText ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbs ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsProd ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsSignature ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsLHS ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsElements ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsElement ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsAlts ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkAbsAlt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkBottomUpRule ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMap ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapSymbol ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapRule ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapChains ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapMember ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapMembers ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapProd ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapReorder ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapLHS ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapDelim ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapAlt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapElement ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapReorderAlt ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapPosition ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkMapText ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkSource ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkBottomUpRules ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkG15 ELI_ARG((POSITION *_coordref, NODEPTR _currn));
extern NODEPTR MkpConProd ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR MkpConLHS ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConIdnElt ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConTextElt ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConActionElt ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConAtModIdn ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConAtModTxt ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConDollarModIdn ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConDollarModTxt ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpConIdent ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpConText ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpAbsProd ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR MkpAbsLHS ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpAbsEmptyRule ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpAbsRule ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR MkpAbsEltIdn ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpAbsEltTxt ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpAbsEltGen ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpAbsListof ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR MkpAbsAltIdn ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpMapSymbol ELI_ARG((POSITION *_coordref, int _TERM1, NODEPTR _desc1));
extern NODEPTR MkpMapProdReorder ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR MkpMapProd ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR MkpMapIdnElt ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpMapTextElt ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpMapReorder ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR MkpMapPosition ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR MkpMapText ELI_ARG((POSITION *_coordref, int _TERM1));
extern NODEPTR Mkrule_000 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_001 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_002 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_003 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_004 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_005 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_006 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_007 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_008 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_009 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_010 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_011 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_012 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
extern NODEPTR Mkrule_013 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_014 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3));
extern NODEPTR Mkrule_015 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2, NODEPTR _desc3, NODEPTR _desc4));
extern NODEPTR Mkrule_016 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_017 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_018 ELI_ARG((POSITION *_coordref, NODEPTR _desc1));
extern NODEPTR Mkrule_019 ELI_ARG((POSITION *_coordref));
extern NODEPTR Mkrule_020 ELI_ARG((POSITION *_coordref, NODEPTR _desc1, NODEPTR _desc2));
#define Mk0rule_1(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_1 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_1 ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0rule_2(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_2 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_2 ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0rule_3(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_3 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_3 ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0rule_4(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_4 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_4 ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0rule_5(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_5 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_5 ELI_ARG((POSITION *_coordref, NODEPTR t));
extern NODEPTR Mkrule_6 ELI_ARG((POSITION *_coordref, int _TERM1));
#define Mk0rule_7(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_7 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_7 ELI_ARG((POSITION *_coordref, NODEPTR t));
extern NODEPTR Mkrule_8 ELI_ARG((POSITION *_coordref, int _TERM1));
#define Mk0rule_9(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_9 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_9 ELI_ARG((POSITION *_coordref, NODEPTR t));
extern NODEPTR Mkrule_10 ELI_ARG((POSITION *_coordref, int _TERM1));
#define Mk0rule_11(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_11 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_11 ELI_ARG((POSITION *_coordref, NODEPTR t));
#define Mk0rule_12(_coordref) NULLNODEPTR
extern NODEPTR Mk2rule_12 ELI_ARG((POSITION *_coordref, NODEPTR l, NODEPTR r));
extern NODEPTR Mkrule_12 ELI_ARG((POSITION *_coordref, NODEPTR t));
extern NODEPTR Mkrule_13 ELI_ARG((POSITION *_coordref));
#define MkInteger(pos,val) (val)
#define MkText(pos,val) (val)
#define MkIdentifier(pos,val) (val)
#endif
